import XenAPI
import MySQLdb
import time
import parse_rrd
import re
import math
import json
import datetime
import calendar
import traceback
import sys
import os

# may need :
#pip install mysqlclient

def getServerList(db,serv):

    # prepare a cursor object using cursor() method
    cursor = db.cursor()

    # Prepare SQL query to INSERT a record into the database.
    sql = " select id,name,ipaddress,hostname,username,password,type from tblservers where type='Xenica' and disabled='0' and id ="+str(serv)+" "
    try:
       # Execute the SQL command
       cursor.execute(sql)
       # Fetch all the rows in a list of lists.
       results = cursor.fetchall()
       servers = []
       for row in results:
            servers.append({'id' : row[0],'name' : row[1],'ipaddress' : row[2],'hostname' : row[3]})

    except:
       print "Error: unable to fecth data from tblservers"
    return servers
    # disconnect from server
    #db.close()
	

	
	
	
def calculate_traffic(rrd_updates, vm_uuid):
    #time_now = int(time.time())
    vifpattern = re.compile("vif_[0-9]+_[rt]x")
    stepsize = rrd_updates.step_time
    total = 0
    for param_name in rrd_updates.get_vm_param_list(vm_uuid):
        if vifpattern.match(param_name):
            #total[param_name] = 0
            for row in range(rrd_updates.get_nrows()):
                try:
                    averageperstep = 0
                    vm__data = rrd_updates.get_vm_data(vm_uuid, param_name, row)
                    if vm__data :
                        averageperstep = float(vm__data)
                    if ( averageperstep > 0 ) and ( not math.isnan(averageperstep) ):
                        totalperstep = stepsize * averageperstep
                        total += totalperstep/1024/1024 #/8 removed !!
                except: 
                    print "*warning function get_vm_data give bad result : "+str(rrd_updates.get_vm_data(vm_uuid, param_name, row))
    return total
	
	
	
	
	
def gethostinginfo(db,vmname):
    cursor = db.cursor()
    sql = " select id,server,regdate,billingcycle,nextduedate,username,lastupdate,bwusage from tblhosting where username='{vmname}'".format(vmname = vmname)
    try:
        # Execute the SQL command
        cursor.execute(sql)
        results = cursor.fetchall()
        # Commit your changes in the database
        for row in results:
           return {'id':row[0],'server':row[1],'regdate':row[2],'billingcycle':row[3],'nextduedate':row[4],'username':row[5],'lastupdate':row[6],'bwusage': row[7]}
    except:
        print "Error: unable to fecth data from tblhosting"
		
		
		
		
		
def add_months(sourcedate,months):
    month = sourcedate.month - 1 + months
    year = int(sourcedate.year + month / 12 )
    month = month % 12 + 1
    day = min(sourcedate.day,calendar.monthrange(year,month)[1])
    return datetime.date(year,month,day)
	
	
	
	

def getVMName(db,uuid):
    cursor = db.cursor()
    sql = " select vmname from xenica_uuid_mapping where uuid='{uuid}'".format(uuid = uuid)

    try:

    # Execute the SQL command
        cursor.execute(sql)
        results = cursor.fetchall()
        # Commit your changes in the database
        for row in results:
           return row[0]
    except:
    # Rollback in case there is any error
       print "Error: unable to fecth data from xenica_uuid_mapping"
	   
# in case of using python 2.6 , the total_seconds() is not defined , so we define a replacement function
def timedelta_total_seconds(timedelta):
    return (
        timedelta.microseconds + 0.0 +
        (timedelta.seconds + timedelta.days * 24 * 3600) * 10 ** 6) / 10 ** 6	   
	   
	   
def updateTraffic(db,vmname,traffictotal):
    try:
        print " "
        print "*"+vmname
        print "Traffic input :" + str(traffictotal)
        cursor = db.cursor()
        serverinfodict = gethostinginfo(db,vmname)
        #print "VM hosting info are:"
        #print serverinfodict
        if serverinfodict is None:
            print "****************** Note: It seems that ["+ str(vmname)+ "] does not pay ! *******************"
            return

        now = datetime.datetime.now()
        print "last update : "+ str(serverinfodict['lastupdate'])
        #in case we duplicate servers in whmcs, or in case we put pool slave with pool master , 
        #in this case same VMs will has duplicated values  ! 
        #so last update must be more than 3 mins (3min must be safe for script execution time)
        vmlastupdate = serverinfodict['lastupdate']
        if vmlastupdate is None:
            vmlastupdate = now - datetime.timedelta(minutes = 60)
        lastrun =  timedelta_total_seconds(now - vmlastupdate)
        if (lastrun <= 180) : 
            print "- VM traffic already added from less than 3 mins "
            return

        #next_due_date = get_next_due_date(serverinfodict)
        #print "Next due date: "+str(next_due_date)
        start_of_month = datetime.datetime(now.year,now.month,1) #datetime.today().replace(day=1)
        #BWinfo = get_servarica_bw_info(db,serverinfodict['id'],serverinfodict['nextduedate'])
        #print "Current Usage :" + str(BWinfo['currenNettUsage'])
        #after3hours = datetime.datetime.strptime('0300','%H%M').time()
        #comparedatetime = datetime.datetime.combine(start_of_month, after3hours) #3 hours gab
        if vmlastupdate >= start_of_month:
            traffictotal = round(float(serverinfodict['bwusage'])+traffictotal)
        print "Total Traffic : "+ str(traffictotal)
        sql1 = "UPDATE tblhosting SET bwusage='{traffictotal}',lastupdate=NOW() WHERE username='{username}'".format(traffictotal=traffictotal, username=vmname)
        #sql2 = "UPDATE xenica_bandwidth SET currenNettUsage='{traffictotal}'  WHERE hostingid='{hostingid}'".format(traffictotal=traffictotal,hostingid=serverinfodict['id'])
        if float(serverinfodict['bwusage']) != traffictotal :
            try:
               # Execute the SQL command
               cursor.execute(sql1)
               #cursor.execute(sql2)
               # Commit your changes in the database
               db.commit()
            except:
               # Rollback in case there is any error
               db.rollback()
    except Exception as inst:
            print "Error updateTraffic for a VM  got Exception"
            print inst
            traceback.print_exc()
			
			
			
			
#use :								1		2    	 3		  4			5	
#/usr/bin/python getTraffic.py mysqluser mysqlpass dbname serverid  serverpass
			
def main():
    db = MySQLdb.connect("localhost", sys.argv[1], sys.argv[2], sys.argv[3])
    servers = getServerList(db,sys.argv[4])

    filexml = os.path.dirname(os.path.realpath(__file__))+"/../rrds/server_"+sys.argv[4]+".xml"
    now = time.time()
    lastcrontime = now
    if os.path.exists(filexml):
        lastcrontime = os.path.getmtime(filexml)
    lastcrondiff = now - lastcrontime

# if less than 60 sec close
    if (lastcrondiff > 0) :
        if (lastcrondiff <= 180) :
            print "Last Cron for this server runs from less than 3 mins"
            return
    else :
        lastcrondiff = 3600
    print "Last Cron Duration for this server "+ str(lastcrondiff)

    for serverdict in servers:
        try:
            url = "http://"+serverdict['ipaddress']
            session = XenAPI.Session(url)
            password =sys.argv[5]
            print "<u>Update Server Traffic Data :</u>"

            session.xenapi.login_with_password('root',password)
            hosts = session.xenapi.host.get_all()
            if len(hosts)<=0 :
                print "* EMPTY Hosts list on this Server !"
                print ""

            for host in hosts:
                hostaddress= session.xenapi.host.get_address(host)
                print ""
                print "     <i>Connecting to host </i>" + str(hostaddress)
                rrd_updates = parse_rrd.RRDUpdates()
                params = {}
                params['cf'] = "AVERAGE"
                params['start'] = int(time.time()) - int(lastcrondiff) -120 # (120sec gap) it was 3600 instead of lastcrondiff
                params['interval'] = 60
                params['host'] = ""  
                rrd_updates.refresh(session.handle, params, "http://"+str(hostaddress), sys.argv[4])
                for uuid in rrd_updates.get_vm_list():
                    vmname = getVMName(db,uuid)
                    if vmname is None :
                        print ""
                        print "*Notice : VM uuid ["+ str(uuid) + "] in server "+serverdict['name'] +" does not have vmname mapping in this WHMCS."
                        continue
                    #2- get start and end time from this period for the user
                    #3- now if we exceeded the end date by 3 hours write only the new value
                    #if newuuidtraffic > 0 
                    newuuidtraffic = calculate_traffic(rrd_updates,uuid)
                    updateTraffic(db,vmname,newuuidtraffic)

                #print json.dumps(finalTotalList, indent=2)
        except Exception as inst:
            print "main catch loop got somthing"
            print inst
            traceback.print_exc()

main()
