<?php
include_once dirname(realpath(__FILE__)) . '/' . "XenFunctions.php";
include_once dirname(realpath(__FILE__)) . '/' . "XenAPI.php";
include_once dirname(realpath(__FILE__)) . '/' . "config.php";

//include_once dirname(realpath(__FILE__)) . '/' . "XenVm.php";

use WHMCS\ClientArea;

function widget_Xenica_VMs($vars) {
    $qry="SELECT h.id,h.username,h.domain,h.dedicatedip,s.name as server,s.id as sid FROM tblhosting as h,tblservers as s WHERE ((h.server=s.id) AND (s.type='Xenica') AND (s.disabled='0')) ORDER BY h.id DESC  LIMIT 10; ";
	$result = Xenica_DB_Query($qry, array(),'DB Error!',false);
	//echo "<pre>".print_r($result,true)."</pre>";
    if (!empty($result)){
        $content = '<table class="table table-condensed">
        <tr bgcolor="#efefef">
		<th class="text-center">VM Name</th>
		<th class="text-center">Domain</th>
		<th class="text-center">Dedicated IP</th>
		</tr>';
        foreach ($result as $VM) {
            $content .= "<tr bgcolor='#fefefe' style='text-align:center;'>
			<td><a href='clientsservices.php?id={$VM['id']}'><b>{$VM['username']}</b></a></td>
			<td>{$VM['domain']}</td>
			<td>{$VM['dedicatedip']}</td>
			</tr>";
        }
        $content .= '</table>';
    } else
        $content = "No VMs Available!";

    return array('title' => 'Last 10 Xenica VMs', 'content' => $content);

}

add_hook("AdminHomeWidgets", 1, "widget_Xenica_VMs");


/**
 * Insert a service item to the client area navigation bar.
 *
 * adding an additional link to the Services navbar menu that
 * provides a shortcut to a filtered products/services list showing only the
 * products/services assigned to the module.
 *
 * @param \WHMCS\View\Menu\Item $menu
 */
add_hook('ClientAreaPrimaryNavbar', 1, function ($menu) {
    $user_xenica_servies = Xenica_DB_GetSingleValue("SELECT COUNT(`id`) as `number` FROM `tblhosting` WHERE (`userid` = '%d') AND (`server` in (SELECT `id` FROM `tblservers` WHERE `type` = %d));", array($_SESSION['uid'], "Xenica"), 'DB Error!', false);
    $has_xenica = intval($user_xenica_servies);

    if ($has_xenica > 0) {
        $translate = Xenica_Server_initTranslate();
        // Check whether the services menu exists.
        if (!is_null($menu->getChild('Services'))) {
            // Add a link to the module filter.
            $menu->getChild('Services')
                ->addChild(
                    $translate->_('List All VMs'),
                    array(
                        'uri' => 'clientarea.php?action=services&module=Xenica',
                        'order' => 15,
                    )
                );
        }
    }
});

/**
 * Render a custom sidebar panel in the secondary sidebar.
 *
 * Demonstrates the creation of an additional sidebar panel on any page where
 * the My Services Actions default panel appears and populates it with a title,
 * icon, body and footer html output and a child link.  Also sets it to be in
 * front of any other panels defined up to this point.
 *
 * @param \WHMCS\View\Menu\Item $secondarySidebar
 */
add_hook('ClientAreaSecondarySidebar', 1, function ($secondarySidebar) {
    $user_xenica_servies = Xenica_DB_GetSingleValue("SELECT COUNT(`id`) as `number` FROM `tblhosting` WHERE (`userid` = '%d') AND (`server` in (SELECT `id` FROM `tblservers` WHERE `type` = %d));", array($_SESSION['uid'], "Xenica"), 'DB Error!', false);
    $has_xenica = intval($user_xenica_servies);

    if ($has_xenica > 0) {
        $translate = Xenica_Server_initTranslate();
        // determine if we are on a page containing My Services Actions
        if (!is_null($secondarySidebar->getChild('My Services Actions'))) {

            // define new sidebar panel
            $customPanel = $secondarySidebar->addChild($translate->_('Xenica Sidebar'));

            // set panel Header/footer
            $customPanel->moveToFront()
                ->setIcon('fa-user')
                ->setBodyHtml(
                    ''
                )
                ->setFooterHtml(
                    ''
                );

            // define link
            $customPanel->addChild(
                $translate->_('List All VMs'),
                array(
                    'uri' => 'clientarea.php?action=services&module=Xenica',
                    'icon' => 'fa-list-alt',
                    'order' => 2,
                )
            );

        }
    }
});
