echo "vm_creation_set_ips"
networkFile="/etc/network/interfaces"
ips_count_array=($(xenstore-list vm-data/xenica_ifs))
ips_count=${#ips_count_array[@]}
if ((ips_count == 0)); then
echo "No IPs found in XenStore" >&2
else
echo "Adding $ips_count IPs from XenStore:"
echo "source /etc/network/interfaces.d/*
auto lo
iface lo inet loopback
" >$networkFile
 ips_array=()
 for i in "${ips_count_array[@]}"; do
field_count_array=("$(xenstore-list vm-data/xenica_ifs/"$i")")
 if [[ " ${field_count_array[*]} " =~ "ip6" ]]; then
 ipv6=1
 xenica_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip6)
 xenica_gateway=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway6)
 xenica_broadcast=$(xenstore-read vm-data/xenica_ifs/"$i"/broadcast6)
 xenica_cidr=$(xenstore-read vm-data/xenica_ifs/"$i"/cidr6)
 else
 ipv6=0
 xenica_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip)
 xenica_gateway=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway)
 xenica_broadcast=$(xenstore-read vm-data/xenica_ifs/"$i"/broadcast)
 xenica_cidr=$(xenstore-read vm-data/xenica_ifs/"$i"/cidr)
 fi
 if [ -z "$xenica_ip" ]; then
 continue
 fi
 echo "Adding : $xenica_ip .."
 if [[ ! "${ips_array[*]}" =~ ${xenica_ip} ]]; then
 ips_array+=("$xenica_ip")

 if [ $i -eq "0" ]; then
 echo "

 # The primary network interface" >>"$networkFile"
 net_name="enX0"
 else
 echo "
 
 # Interface aliase $i" >>"$networkFile"
 net_name="enX0:""$i"
 fi

 echo "auto $net_name" >>"$networkFile"
 echo "allow-hotplug $net_name" >>"$networkFile"

 if [ $ipv6 -eq "1" ]; then
 echo "iface $net_name inet6 static" >>"$networkFile"
 echo "pre-up modprobe ipv6" >>"$networkFile"
 echo "        address $xenica_ip" >>"$networkFile"
 echo "netmask $xenica_cidr" >>"$networkFile"
 else
 echo "iface $net_name inet static" >>"$networkFile"
 echo "        address $xenica_ip/$xenica_cidr" >>"$networkFile"
 fi
 if [ $i -eq "0" ]; then
 echo "        gateway $xenica_gateway" >>"$networkFile"
 echo "        dns-search debian.net $xenica_broadcast" >>"$networkFile"
 fi
 fi
 sleep 1
 done

 touch "/opt/need_to_reboot.log"
 fi
