#vm_creation_set_ips|

echo "- Setting IPs .."
 networkFile="/etc/sysconfig/network/ifcfg-eth0"
 #read vm-data/xenica_ifs and save in array
 ips_count_array=($(xenstore-list vm-data/xenica_ifs))
 ips_count=${#ips_count_array[@]}
 if ((ips_count == 0)); then
 echo "No IPs found in XenStore" >&2
 else
 rm -f /etc/sysconfig/network/ifcfg-eth*
 rm -f /etc/sysconfig/network/ifroute-eth*
 #rm -f /etc/sysconfig/network/routes
 echo "BOOTPROTO='static'" >"$networkFile"
 echo "STARTMODE='auto'" >>"$networkFile"
 echo
 ips_array=()
 gws_array=()
 for i in "${ips_count_array[@]}"; do
 #check if IP is v6
field_count_array=("$(xenstore-list vm-data/xenica_ifs/"$i")")
 if [[ " ${field_count_array[*]} " =~ "ip6" ]]; then
 ipv6=1
 xenica_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip6)
 xenica_gateway=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway6)
 xenica_subnetmask=$(xenstore-read vm-data/xenica_ifs/"$i"/netmask6)
 else
 ipv6=0
 xenica_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip)
 xenica_gateway=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway)
 xenica_subnetmask=$(xenstore-read vm-data/xenica_ifs/"$i"/netmask)
 fi
 if [ -z "$xenica_ip" ]; then
 continue
 fi
 echo "Adding IP Address: $xenica_ip .."
 # we add this part just to make sure no duplicates values
 #if xenica_ip not in ips_array
 if [[ ! "${ips_array[*]}" =~ ${xenica_ip} ]]; then
 ips_array+=("$xenica_ip")
 if [[ "$i" -eq "0" ]]; then
 ip_suffex=""
 else
 ip_suffex="_""$i"
 fi
 # default case: echo " - $xenica_ip/$xenica_subnetmask" >> $networkFile
 if [ $ipv6 -eq "1" ]; then
 echo "IPADDR""$ip_suffex='$xenica_ip/36'" >>"$networkFile"
 else
 echo "IPADDR""$ip_suffex='$xenica_ip/24'" >>"$networkFile"
 fi
 echo "LABEL""$ip_suffex='IP_$i'" >>"$networkFile"
 echo
 #if xenica_gateway not in gws_array
 if [[ ! "${gws_array[*]}" =~ ${xenica_gateway} ]]; then
 gws_array+=("$gws_array")
 echo "default $xenica_gateway - - " >>"/etc/sysconfig/network/ifroute-eth0"
 fi
 fi
 done
 touch "/opt/need_to_reboot.log"
 fi