#!/bin/bash
echo "- Setting IPs .."
 networkFile="/etc/sysconfig/network-scripts/ifcfg-eth0"
 ips_count_array=($(xenstore-list vm-data/xenica_ifs))
 ips_count=${#ips_count_array[@]}
 if ((ips_count == 0)); then
 echo "No IPs found" >&2
 else
 echo "TYPE=\"Ethernet\"" >"$networkFile"
 echo "DEVICE=\"eth0\"" >>"$networkFile"
 echo "BOOTPROTO=\"static\"" >>"$networkFile"
 echo "ONBOOT=\"yes\"" >>"$networkFile"
 echo
 ip4_cont=0
 ip6_cont=0
 ips_arr=()
 for i in "${ips_count_array[@]}"; do
field_count_array=("$(xenstore-list vm-data/xenica_ifs/"$i")")
 if [[ " ${field_count_array[*]} " =~ "ip6" ]]; then
 ipv6=1
 x_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip6)
 x_gw=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway6)
 x_submask=$(xenstore-read vm-data/xenica_ifs/"$i"/netmask6)
 ip6_cont=$(($ip6_cont + 1))
 else
 ipv6=0
 x_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip)
 x_gw=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway)
 x_submask=$(xenstore-read vm-data/xenica_ifs/"$i"/netmask)
 ip4_cont=$(($ip4_cont + 1))
 fi
 if [ -z "$x_ip" ]; then
 continue
 fi
 echo "Adding IP Address: $x_ip .."
 if [[ ! "${ips_arr[*]}" =~ ${x_ip} ]]; then
 ips_arr+=("$x_ip")
 if [[ "$i" -eq "0" ]]; then
 rm -f /etc/sysconfig/network-scripts/ifcfg-eth0:*
 fi
 if [ "$ipv6" -eq "1" ]; then
 if [ "$ip6_cont" -eq "1" ]; then
 ipno=""
 echo "IPV6INIT=\"yes\"" >>"$networkFile"
 echo "IPV6_AUTOCONF=\"no\"" >>"$networkFile"
 echo "IPV6_DEFROUTE=\"yes\"" >>"$networkFile"
 echo "IPV6_FAILURE_FATAL=\"no\"" >>"$networkFile"
 else
 ipno="$((ip6_cont - 1))"
 fi
 echo "IPV6ADDR""$ipno""=\"$x_ip/36\"" >>"$networkFile"
 echo "IPV6_DEFAULTGW""$ipno""=\"$x_gw\"" >>"$networkFile"
 else
 if [ $ip4_cont -eq "1" ]; then
 ipno=""
 else
 ipno="$((ip4_cont - 1))"
 fi
 echo "IPADDR""$ipno""=\"$x_ip\"" >>"$networkFile"
 echo "NETMASK""$ipno""=\"$x_submask\"" >>"$networkFile"
 echo "GATEWAY""$ipno""=\"$x_gw\"" >>"$networkFile"
 fi
 fi
 done
 touch "/opt/need_to_reboot.log"
 fi