#!/usr/bin/env bash
echo "- Setting IPs .."
export networkFile="/etc/netplan/50-cloud-init.yaml"
ips_count_array=($(xenstore-list vm-data/xenica_ifs))
ips_count=${#ips_count_array[@]}
if ((ips_count == 0)); then
echo "No IPs found"
else
echo "Adding $ips_count IPs:"
echo "
network:
    ethernets:
        enX0:
            addresses:" >$networkFile
ips_array=()
gw_arr6=()
gw_arr=()
for i in "${ips_count_array[@]}"; do
field_count_array=("$(xenstore-list vm-data/xenica_ifs/"$i")")
if [[ " ${field_count_array[*]} " =~ "ip6" ]]; then
ipv6=1
xenica_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip6)
xenica_gateway=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway6)
xenica_cidr=$(xenstore-read vm-data/xenica_ifs/"$i"/cidr6)
else
ipv6=0
xenica_ip=$(xenstore-read vm-data/xenica_ifs/"$i"/ip)
xenica_gateway=$(xenstore-read vm-data/xenica_ifs/"$i"/gateway)
xenica_cidr=$(xenstore-read vm-data/xenica_ifs/"$i"/cidr)
fi
if [[ -z "$xenica_ip" ]]; then
continue
fi
echo "IP: $xenica_ip .."
ips_array+=("$xenica_ip")
if [[ "$ipv6" -eq "1" ]]; then
  echo "                - $xenica_ip/$xenica_cidr" >>"$networkFile"
  if [[ ! "${gw_arr6[*]}" =~ ${xenica_gateway} ]]; then
  gw_arr6+=("$xenica_gateway")
  fi
else
  echo "                - $xenica_ip/$xenica_cidr" >>"$networkFile"
  if [[ ! "${gw_arr[*]}" =~ ${xenica_gateway} ]]; then
   gw_arr+=("$xenica_gateway")
  fi
fi
done
echo "            routes:" >>$networkFile
for item in "${gw_arr[@]}"; do
echo "                - to: default
                  via: $item" >>$networkFile
done
for item in "${gw_arr6[@]}"; do
echo "                - to: default
                  via: $item" >>$networkFile
done
echo "            dhcp4: false
            dhcp6: false" >>$networkFile
 touch "/opt/need_to_reboot.log"
 fi