# Servarica Xen Module Software License Agreement
# thanks to http://wiki.polymorf.fr/index.php?title=Tips:XenServer-Network-Autoconfiguration-for-Windows-using-WMI-and-PowerShell
# for the script 
# XenServer autoconfig for Windows using xenstore-data
 

$LogFile = "C:\XenicaAutoConf\logs\vm_creation_config.log"

Function Log {
	Param ([string] $message)
	echo $message
	Add-Content $LogFile -value $message
}
 
log "set initial settings on First Boot .."

# Locate the base object 
$base = gwmi -n root\wmi -cl CitrixXenStoreBase 
# Create a session 
$sid = $base.AddSession("Xenautostart") 
$session = gwmi -n root\wmi -q "select * from CitrixXenStoreSession where SessionId=$($sid.SessionId)" 
 
# -- Get value from XenStore
$hostname = $session.GetValue("vm-data/xenica_hostname").value
$password = $session.GetValue("vm-data/xenica_passwd").value

log "- changing hostname .."
# - Hostname
$computer = Get-WmiObject -class win32_computersystem
$ret = $computer.Rename("$hostname").ReturnValue
if ( $ret -eq 0 ) {
	log "[ok] set hostname to $hostname"
}else{
	log "[error] can't set hostname to $hostname"
}

log "- changing root pass .."
#change the password
([adsi]"WinNT://./Administrator").SetPassword("$password")
log "Password changed to $password"

Add-Content C:\XenicaAutoConf\logs\need_to_reboot.log -value "reboot"





