Function Log {
 Param ([string] $message)
 echo $message
 Add-Content C:\XenicaAutoConf\logs\Set_IPs.log -value $message
}
 
log "Setting IPs :"
$base = gwmi -n root\wmi -cl CitrixXenStoreBase 
$sid = $base.AddSession("Xenautostart") 
$session = gwmi -n root\wmi -q "select * from CitrixXenStoreSession where SessionId=$($sid.SessionId)" 
 
$ips = @()
$netmasks = @()
$gateways = @()
$if_nodes = $session.GetChildren("vm-data/xenica_ifs").children.ChildNodes
foreach ( $if_node in $if_nodes ) {
$node_child = $session.GetChildren("$if_node").children.ChildNodes	
 if ( $node_child -like "*ip6*"){
  $ip = $session.GetValue("$if_node/ip6").value
  $netmask = $session.GetValue("$if_node/netmask6").value
  $gateway = $session.GetValue("$if_node/gateway6").value
 }else{
 $ip = $session.GetValue("$if_node/ip").value
 $netmask = $session.GetValue("$if_node/netmask").value
 $gateway = $session.GetValue("$if_node/gateway").value
 }
 log "$if_node/ip : $ip"
 $ips += $ip
 $netmasks += $netmask
 $gateways += $gateway
}

$ips | Out-File C:\XenicaAutoConf\ips.txt
$netmasks | Out-File C:\XenicaAutoConf\netmasks.txt
$gateways | Out-File C:\XenicaAutoConf\gateways.txt

$ifcfg = Get-WmiObject win32_networkadapterconfiguration | where{$_.IPEnabled -eq "True"}
$ifname = $ifcfg.Description
$ret = $ifcfg.EnableStatic($ips,$netmasks).ReturnValue
if ( $ret -eq 0 ) {
 log "[ok] set IPs on '$ifname'"
}else{
 log "[error] can't set IPs on '$ifname', error code [$ret]"
}
if ( $gateways ) {
 $ret = $ifcfg.SetGateways($gateways).ReturnValue
 if ( $ret -eq 0 ) {
  log "[ok] set gateways"
 }else{
  log "[error] can't set gateways on '$ifname'"
 }
}

Add-Content C:\XenicaAutoConf\logs\need_to_reboot.log -value "reboot"