
$LogFile = "C:\XenicaAutoConf\logs\set_nameservers.log"

Function Log {
	Param ([string] $message)
	echo $message
	Add-Content $LogFile -value $message
}
 
log "changing NameServers .."

# Locate the base object 
$base = gwmi -n root\wmi -cl CitrixXenStoreBase 
# Create a session 
$sid = $base.AddSession("Xenautostart") 
$session = gwmi -n root\wmi -q "select * from CitrixXenStoreSession where SessionId=$($sid.SessionId)" 
 
# -- Get value from XenStore
$nameservers = @($session.GetValue("vm-data/xenica_nameserver1").value,$session.GetValue("vm-data/xenica_nameserver2").value)
if ( $nameservers -eq $null ) {
	$nameservers = @('8.8.8.8', '8.8.4.4')
	}
	
$nameservers | Out-File C:\XenicaAutoConf\nameservers.txt

log "[xenstore-value] vm-data/nnameserver[1,2] : $nameservers"
 
$netcfg = Get-WmiObject win32_networkadapterconfiguration -filter "ipenabled = 'true'"
$ret = $netcfg.SetDNSServerSearchOrder($nameservers).ReturnValue
if ( $ret -eq 0 ) {
	log "[ok] set nameservers to $nameservers"
}else{
	log "[error] can't set nameservers to $nameservers"
}

Add-Content C:\XenicaAutoConf\logs\need_to_reboot.log -value "reboot"